/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package marg.model;

import marg.test.mockserver.JUnitMockServer;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Daniel
 */
public class XMLClientTest {

    public XMLClientTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of sendCmd method, of class XMLClient.
     */
    @Test
    public void testSendCmd() throws InterruptedException {
        System.out.println("sendCmd");
        JUnitMockServer mock = new JUnitMockServer(24001);
        XMLClient client = new XMLClient();
        client.connect("localhost", 24001);
        client.sendCmd("testing");
        String expResult = "<testing/>";
        Thread.sleep(200); //Delay for the server thread
        String result = mock.getLastReceivedCmd();
        assertEquals(expResult, result);
    }

    /**
     * Test of getXMLParser method, of class XMLClient.
     */
    @Test
    public void testGetXMLParser() {
        System.out.println("getXMLParser");
        XMLClient instance = new XMLClient();
        XMLParser result = instance.getXMLParser();
        assertTrue(result instanceof XMLParser);
    }

    @Test
    public void testConnect() {
        XMLClient client = new XMLClient();
        try {
            client.connect("localhost", 65536); //Port out of bound
            fail("Expected IllegalArgumentException");
        } catch (IllegalArgumentException ex) {}
        try {
            client.connect("localhost", 1023); //Port out of bound
            fail("Expected IllegalArgumentException");
        } catch (IllegalArgumentException ex) {}
        assertFalse(client.isConnected());
    }

    @Test
    public void testConnect2() {
        JUnitMockServer mock = new JUnitMockServer(65535); //Highes possible port
        XMLClient client = new XMLClient();
        client.connect("localhost", 65535);
        assertEquals(client.isConnected(), true);
    }

    @Test
    public void testConnect3() {
        JUnitMockServer mock = new JUnitMockServer(1024); //Lowest possible port
        XMLClient client = new XMLClient();
        client.connect("localhost", 1024);
        assertEquals(client.isConnected(), true);
    }

    @Test
    public void testDisconnect() {
        JUnitMockServer mock = new JUnitMockServer(24002);
        XMLClient client = new XMLClient();
        client.connect("localhost", 24002);
        assertTrue(client.isConnected());
        client.disconnect();
        assertFalse(client.isConnected());
    }
}
