/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package marg.test.mockserver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Daniel
 */
public class MockAllCopyServer implements Runnable {

    private String lastReceivedCmd = "";
    private String rootElement = "mockServer";
    private String dummyAnswer = "<var name=\"core.test.deep.struct.version\" typ=\"d\" value=\"2.04\"/>";
    private int port;

    public MockAllCopyServer(int port) {
        this.port = port;
        Thread t = new Thread(this);
        t.start();
    }

    public void run() {
        try {
            String sentence;
            ServerSocket serverSocket = new ServerSocket(port);
            while (true) {
                System.out.println("Server Started: Listening on port " + port);
                Socket socket = serverSocket.accept();
                PrintWriter outToClient = new PrintWriter(socket.getOutputStream(), true);
                BufferedReader inFromClient = new BufferedReader(new InputStreamReader(socket.getInputStream()));
                System.err.println("Connection OPENED. " + new Date());
                System.out.println("Client IP: " + socket.getInetAddress());
                outToClient.println("<" + rootElement + ">");

                try {
                    File allCopyFile1 = new File("var_allcopyd1.xml"); //relative path
                    File allCopyFile2 = new File("var_allcopyd2.xml"); //relative path
                    System.out.println(allCopyFile1.getAbsolutePath());
                    while ((sentence = inFromClient.readLine()) != null && !sentence.equals("<quit/>")) {
                            System.out.println("Received cmd: " + sentence);
                            lastReceivedCmd = sentence;
                            sendFileContents(allCopyFile1, socket.getOutputStream());
                            try {
                                Thread.sleep(1000);
                            } catch (InterruptedException ex) {
                                Logger.getLogger(MockAllCopyServer.class.getName()).log(Level.SEVERE, null, ex);
                            }
                            sendFileContents(allCopyFile2, socket.getOutputStream());
                    }
                    outToClient.println("</" + rootElement + ">");
                    System.err.println("Connection CLOSED.");
                    socket.close();
                } catch (SocketException ex) {
                } finally {
                    if (socket != null) {
                        socket.close();
                    }
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(MockAllCopyServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void setDummyAnswer(String dummyAnswer) {
        this.dummyAnswer = dummyAnswer;
    }

    public String getLastReceivedCmd() {
        return lastReceivedCmd;
    }

    public static void main(String[] args) {
        MockAllCopyServer mock = new MockAllCopyServer(24930);
    }

    public void sendFileContents(File file, OutputStream out) {
        try {
            FileInputStream inFile = new FileInputStream(file);
            copyContents(inFile, out);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MockAllCopyServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void copyContents(InputStream from, OutputStream to) {
        try {
            byte[] buffer = new byte[512];
            int bytesRead = 0;
            while (((bytesRead = from.read(buffer)) != -1)) {
                to.write(buffer, 0, bytesRead);
                buffer = new byte[512];
            }
            to.flush();
        } catch (IOException ex) {
            Logger.getLogger(MockAllCopyServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
