/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package marg.test.mockserver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Daniel
 */
public class MockServer implements Runnable {

    private String lastReceivedCmd = "";
    private String rootElement = "mockServer";
    private String dummyAnswer = "<var name=\"core.test.deep.struct.version\" typ=\"d\" value=\"2.04\"/>\n" +
            "<var name=\"rhd.linesensor\" typ=\"d\" size=\"9\" valid=\"true\" value=\"1 53 51 53 53 54 54 54 54\"></var>\n" +
            "<var name=\"rhd.irsensor\" typ=\"d\" size=\"7\" valid=\"true\" value=\"1 169 107 90 89 2 255\"></var>";
    private int port;

    public MockServer(int port) {
        this.port = port;
        Thread t = new Thread(this);
        t.start();
    }

    public void run() {
        try {
            String sentence;
            ServerSocket serverSocket = new ServerSocket(port);
            while (true) {
                System.out.println("Server Started: Listening on port " + port);
                Socket socket = serverSocket.accept();
                PrintWriter outToClient = new PrintWriter(socket.getOutputStream(), true);
                BufferedReader inFromClient = new BufferedReader(new InputStreamReader(socket.getInputStream()));
                System.err.println("Connection OPENED. " + new Date());
                System.out.println("Client IP: " + socket.getInetAddress());
                outToClient.println("<"+ rootElement+ ">");
                try {
                while ((sentence = inFromClient.readLine()) != null) {
                    System.out.println("Received cmd: "+ sentence);
                    lastReceivedCmd = sentence;
                    outToClient.println(dummyAnswer);
                    outToClient.flush();
                }
                outToClient.println("</"+ rootElement+ ">");
                System.err.println("Connection CLOSED.");
                socket.close();
                } catch (SocketException ex) {
                    System.err.println("Client DISCONNECTED");
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(MockServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void setDummyAnswer(String dummyAnswer) {
        this.dummyAnswer = dummyAnswer;
    }

    public String getLastReceivedCmd() {
        return lastReceivedCmd;
    }

    public static void main(String[] args) {
        MockServer mock = new MockServer(24928);
    }

    public void sendFileContents(File file, OutputStream out) {
        try {
            FileInputStream inFile = new FileInputStream(file);
            copyContents(inFile, out);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MockServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void copyContents(InputStream from, OutputStream to) {
        try {
            byte[] buffer = new byte[512];
            while ((from.read(buffer) != -1)) {
                to.write(buffer);
                buffer = new byte[512];
            }
            to.flush();
        } catch (IOException ex) {
            Logger.getLogger(MockServer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
