/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package marg.test.mockserver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Date;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Daniel
 */
public class MockServerLineIR implements Runnable {

    private String lastReceivedCmd = "";
    private String rootElement = "mockServer";
    private String irS = "<var name=\"rhd.irsensor\" typ=\"d\" size=\"7\" valid=\"true\" value=\"1 %s %s %s %s %s %s\"></var>";
    private String lineS = "<var name=\"rhd.linesensor\" typ=\"d\" size=\"9\" valid=\"true\" value=\"1 %s %s %s %s %s %s %s %s\"></var>";
    private int port;

    public MockServerLineIR(int port) {
        this.port = port;
        Thread t = new Thread(this);
        t.start();
    }

    public void run() {
        try {
            String sentence;
            ServerSocket serverSocket = new ServerSocket(port);
            while (true) {
                System.out.println("Server Started: Listening on port " + port);
                Socket socket = serverSocket.accept();
                PrintWriter outToClient = new PrintWriter(socket.getOutputStream(), true);
                BufferedReader inFromClient = new BufferedReader(new InputStreamReader(socket.getInputStream()));
                System.err.println("Connection OPENED. " + new Date());
                System.out.println("Client IP: " + socket.getInetAddress());
                outToClient.println("<"+ rootElement +">");
                while ((sentence = inFromClient.readLine()) != null) {
                    System.out.println("Received cmd: " + sentence);
                    lastReceivedCmd = sentence;
                    while (true) {
                        outToClient.println(String.format(lineS, getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), getRandom(5, 128)));
                        outToClient.println(String.format(irS, getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), getRandom(5, 128), 255));
                        outToClient.flush();
                        try {
                            Thread.sleep(1000);
                        } catch (InterruptedException ex) {
                            Logger.getLogger(MockServerLineIR.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                }
                System.err.println("Connection CLOSED.");
                socket.close();
            }
        } catch (IOException ex) {
            Logger.getLogger(MockServerLineIR.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private int getRandom(int min, int max) {
        return min + (int) Math.round((Math.random() * (max - min)));
    }

    public String getLastReceivedCmd() {
        return lastReceivedCmd;
    }

    public static void main(String[] args) {
        MockServerLineIR mock = new MockServerLineIR(24929);
    }

    public void sendFileContents(File file, OutputStream out) {
        try {
            FileInputStream inFile = new FileInputStream(file);
            copyContents(inFile, out);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MockServerLineIR.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void copyContents(InputStream from, OutputStream to) {
        try {
            byte[] buffer = new byte[512];
            while ((from.read(buffer) != -1)) {
                to.write(buffer);
                buffer = new byte[512];
            }
            to.flush();
        } catch (IOException ex) {
            Logger.getLogger(MockServerLineIR.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
