/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package marg.test.mockserver;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.SocketException;
import java.util.Date;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Daniel
 */
public class MockServerWheels implements Runnable {

    private String lastReceivedCmd = "";
    private String rootElement = "mockServer";
    private static final String LEFT_ENCODER_LINE = "<var name=\"rhd.encl\" typ=\"\" size=\"2\" value=\"1 %s\" desc=\"(r) first value is update flag\"/>";
    private static final String RIGHT_ENCODER_LINE = "<var name=\"rhd.encr\" typ=\"\" size=\"2\" value=\"1 %s\" desc=\"(r) first value is update flag\"/>";
    private static final String LEFT_SPEED_LINE = "<var name=\"rhd.speedl\" typ=\"d\" size=\"2\" value=\"1 %s\" desc=\"(w) writeable, first value unused\"/>";
    private static final String RIGHT_SPEED_LINE = "<var name=\"rhd.speedr\" typ=\"d\" size=\"2\" value=\"1 %s\" desc=\"(w) writeable, first value unused\"/>";
    private int encrLeft = 0;
    private int encrRight = 0;
    private int port;

    public MockServerWheels(int port) {
        this.port = port;
        Thread t = new Thread(this);
        t.start();
    }

    public void run() {
        try {
            String sentence;
            ServerSocket serverSocket = new ServerSocket(port);
            while (true) {
                System.out.println("Server Started: Listening on port " + port);
                Socket socket = serverSocket.accept();
                PrintWriter outToClient = new PrintWriter(socket.getOutputStream(), true);
                BufferedReader inFromClient = new BufferedReader(new InputStreamReader(socket.getInputStream()));
                System.err.println("Connection OPENED. " + new Date());
                System.out.println("Client IP: " + socket.getInetAddress());
                outToClient.println("<" + rootElement + ">");

                try {
                    while ((sentence = inFromClient.readLine()) != null) {
                        System.out.println("Received cmd: " + sentence);
                        lastReceivedCmd = sentence;
                        for (int i = 0; i < 20; i++) {
                            encrLeft += 2000;
                            encrRight -= (int) (Math.random() * 600);
                            System.out.println("New values: " + encrLeft + " " + encrRight);
                            outToClient.println(String.format(LEFT_ENCODER_LINE, encrLeft));
                            outToClient.println(String.format(RIGHT_ENCODER_LINE, encrRight));
                            outToClient.println(String.format(RIGHT_SPEED_LINE, -6));
                            outToClient.println(String.format(LEFT_SPEED_LINE, 20));
                            outToClient.flush();
                            try {
                                Thread.sleep(1000);
                            } catch (InterruptedException ex) {
                                Logger.getLogger(MockServerLineIR.class.getName()).log(Level.SEVERE, null, ex);
                            }
                        }
                        outToClient.println(String.format(LEFT_ENCODER_LINE, encrLeft));
                        outToClient.println(String.format(RIGHT_ENCODER_LINE, encrRight));
                    }
                    outToClient.println("</" + rootElement + ">");
                    System.err.println("Connection CLOSED.");
                    socket.close();
                } catch (SocketException ex) {
                    System.err.println("Client DISCONNECTED");
                }
            }
        } catch (IOException ex) {
            Logger.getLogger(MockServerWheels.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public String getLastReceivedCmd() {
        return lastReceivedCmd;
    }

    public static void main(String[] args) {
        MockServerWheels mock = new MockServerWheels(24928);
    }

    public void sendFileContents(File file, OutputStream out) {
        try {
            FileInputStream inFile = new FileInputStream(file);
            copyContents(inFile, out);
        } catch (FileNotFoundException ex) {
            Logger.getLogger(MockServerWheels.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void copyContents(InputStream from, OutputStream to) {
        try {
            byte[] buffer = new byte[512];
            while ((from.read(buffer) != -1)) {
                to.write(buffer);
                buffer = new byte[512];
            }
            to.flush();
        } catch (IOException ex) {
            Logger.getLogger(MockServerWheels.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
