/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package marg.model;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Daniel
 */
public class ValueLimitTest {

    private ValueLimit limitLEQ;
    private ValueLimit limitL;

    public ValueLimitTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        limitLEQ = new ValueLimit(-50.5, ValueLimit.LESS_THAN_EQUALS, 50.5, ValueLimit.LESS_THAN_EQUALS);
        limitL = new ValueLimit(-50.5, ValueLimit.LESS_THAN, 50.5, ValueLimit.LESS_THAN);
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of checkCorrect method, of class ValueLimit.
     */
    @Test
    public void testCheckCorrect() {
        System.out.println("checkCorrect");
        double value = -50.5;
        assertEquals(true, limitLEQ.checkCorrect(value));
        assertEquals(false, limitL.checkCorrect(value));

        value = 0;
        assertEquals(true, limitLEQ.checkCorrect(value));
        assertEquals(true, limitL.checkCorrect(value));

        value = 50.5;
        assertEquals(true, limitLEQ.checkCorrect(value));
        assertEquals(false, limitL.checkCorrect(value));
    }

    /**
     * Test of getMaxValue method, of class ValueLimit.
     */
    @Test
    public void testGetMaxValue() {
        System.out.println("getMaxValue");
        double expResult = 50.5;
        double result = limitLEQ.getMaxValue();
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of getMinValue method, of class ValueLimit.
     */
    @Test
    public void testGetMinValue() {
        System.out.println("getMinValue");
        double expResult = -50.5;
        double result = limitLEQ.getMinValue();
        assertEquals(expResult, result, 0.0);

        result = limitL.getMinValue();
        assertEquals(expResult, result, 0.0);
    }

    /**
     * Test of getMaximumComparison method, of class ValueLimit.
     */
    @Test
    public void testGetMaximumComparison() {
        System.out.println("getMaximumComparison");
        assertEquals(ValueLimit.LESS_THAN, limitL.getMaximumComparison());
        assertEquals(ValueLimit.LESS_THAN_EQUALS, limitLEQ.getMaximumComparison());
    }

    /**
     * Test of getMinimumComparison method, of class ValueLimit.
     */
    @Test
    public void testGetMinimumComparison() {
        System.out.println("getMinimumComparison");
        assertEquals(ValueLimit.LESS_THAN, limitL.getMinimumComparison());
        assertEquals(ValueLimit.LESS_THAN_EQUALS, limitLEQ.getMinimumComparison());
    }

    /**
     * Test of toString method, of class ValueLimit.
     */
    @Test
    public void testToString() {
        System.out.println("toString");
        String expResult = "ValueLimit (min -50.5, max 50.5, MinLTE false, MaxLTE false)";
        assertEquals(expResult, limitL.toString());

        expResult = "ValueLimit (min -50.5, max 50.5, MinLTE true, MaxLTE true)";
        assertEquals(expResult, limitLEQ.toString());
    }

}